/*
 * Registry<Action>.cpp
 *
 *  Created on: Jan 7, 2010
 *      Author: crueger
 */

// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "Helpers/MemDebug.hpp"

#include "Actions/ActionRegistry.hpp"
#include "Patterns/Singleton_impl.hpp"
#include "Patterns/Registry_impl.hpp"

/** Constructor for class ActionRegistry.
 */
ActionRegistry::ActionRegistry()
{}

/** Destructor for class ActionRegistry.
 */
ActionRegistry::~ActionRegistry()
{}

/** Just passes on call to Registry<Action>::getByName().
 * \param name name of Action
 * \return pointer to Action
 */
Action* ActionRegistry::getActionByName(const std::string name)
{
  return getByName(name);
}

/** Just passes on call to Registry<Action>::isPresentByName().
 * \param name name of Action
 * \return true - Action instance present, false - not
 */
bool ActionRegistry::isActionPresentByName(const std::string name)
{
  return isPresentByName(name);
}

CONSTRUCT_SINGLETON(ActionRegistry)
CONSTRUCT_REGISTRY(Action)
