/*
 * Registry<Action>.hpp
 *
 *  Created on: Jan 7, 2010
 *      Author: crueger
 */

#ifndef ACTIONREGISTRY_HPP_
#define ACTIONREGISTRY_HPP_

#include <iosfwd>
#include <string>
#include <map>

#include "Patterns/Registry.hpp"
#include "Patterns/Singleton.hpp"
#include "Actions/Action.hpp"

/** Action Registry.
 *
 * The Action registry is a storage for any Action instance to retrieved by name.
 * It is a singleton and can be called from anywhere.
 *
 */
class ActionRegistry : public Singleton<ActionRegistry>, public Registry<Action>
{
  friend class Singleton<ActionRegistry>;
  //friend class Registry<Action>;

public:
  Action* getActionByName(const std::string name);
  bool isActionPresentByName(const std::string name);

private:
  ActionRegistry();
  ~ActionRegistry();
};

#endif /* ACTIONREGISTRY_HPP_ */
