/*
 * VersionAction.hpp
 *
 *  Created on: May 8, 2010
 *      Author: heber
 */

#ifndef VERSIONACTION_HPP_
#define VERSIONACTION_HPP_

#include "Actions/Action.hpp"
#include "version.h"

void CommandVersion();

class CommandLineVersionAction : public Action {
  friend void CommandVersion();

public:
  CommandLineVersionAction();
  virtual ~CommandLineVersionAction();

  bool canUndo();
  bool shouldUndo();

  virtual const std::string getName();
protected:
  virtual Dialog * fillDialog(Dialog *dialog);
private:
  virtual Action::state_ptr performCall();
  virtual Action::state_ptr performUndo(Action::state_ptr);
  virtual Action::state_ptr performRedo(Action::state_ptr);

  static const char NAME[];
};

#endif /* VERSIONACTION_HPP_ */
