/*
 * DepthFirstSearchAction.hpp
 *
 *  Created on: May 9, 2010
 *      Author: heber
 */

#ifndef DEPTHFIRSTSEARCHACTION_HPP_
#define DEPTHFIRSTSEARCHACTION_HPP_

#include "Actions/Action.hpp"

void FragmentationDepthFirstSearch(double distance);

class FragmentationDepthFirstSearchAction : public Action {
  friend void FragmentationDepthFirstSearch(double distance);

public:
  FragmentationDepthFirstSearchAction();
  virtual ~FragmentationDepthFirstSearchAction();

  bool canUndo();
  bool shouldUndo();

  virtual const std::string getName();
protected:
  virtual Dialog * fillDialog(Dialog *dialog);
private:
  virtual Action::state_ptr performCall();
  virtual Action::state_ptr performUndo(Action::state_ptr);
  virtual Action::state_ptr performRedo(Action::state_ptr);

  static const char NAME[];
};

#endif /* DEPTHFIRSTSEARCHACTION_HPP_ */
