/*
 * FragmentationAction.hpp
 *
 *  Created on: May 9, 2010
 *      Author: heber
 */

#ifndef FRAGMENTATIONACTION_HPP_
#define FRAGMENTATIONACTION_HPP_

#include "Actions/Action.hpp"

void FragmentationFragmentation(std::string &path, double distance, int order);

class FragmentationFragmentationAction : public Action {
  friend void FragmentationFragmentation(std::string &path, double distance, int order);

public:
  FragmentationFragmentationAction();
  virtual ~FragmentationFragmentationAction();

  bool canUndo();
  bool shouldUndo();

  virtual const std::string getName();
protected:
  virtual Dialog * fillDialog(Dialog *dialog);
private:
  virtual Action::state_ptr performCall();
  virtual Action::state_ptr performUndo(Action::state_ptr);
  virtual Action::state_ptr performRedo(Action::state_ptr);

  static const char NAME[];
};

#endif /* FRAGMENTATIONACTION_HPP_ */
