/*
 * AddEmptyBoundaryAction.hpp
 *
 *  Created on: May 8, 2010
 *      Author: heber
 */

#ifndef ADDEMPTYBOUNDARYACTION_HPP_
#define ADDEMPTYBOUNDARYACTION_HPP_

#include "Actions/Action.hpp"
#include "LinearAlgebra/Vector.hpp"

void WorldAddEmptyBoundary(Vector &boundary);

class WorldAddEmptyBoundaryAction : public Action {
  friend void WorldAddEmptyBoundary(Vector &boundary);

public:
  WorldAddEmptyBoundaryAction();
  virtual ~WorldAddEmptyBoundaryAction();

  bool canUndo();
  bool shouldUndo();

  virtual const std::string getName();
protected:
  virtual Dialog * fillDialog(Dialog *dialog);
private:
  virtual Action::state_ptr performCall();
  virtual Action::state_ptr performUndo(Action::state_ptr);
  virtual Action::state_ptr performRedo(Action::state_ptr);

  static const char NAME[];
};

#endif /* ADDEMPTYBOUNDARYACTION_HPP_ */
