/*
 * PointCloud.hpp
 *
 *  Created on: Jul 29, 2010
 *      Author: heber
 */

#ifndef POINTCLOUD_HPP_
#define POINTCLOUD_HPP_

#include <cstdio>

class TesselPoint;
class Vector;

/** Super-class for all point clouds structures, also molecules. They have to inherit this structure and implement the virtual function to access the Vectors.
 * This basically encapsulates a list structure.
 */
class PointCloud {
public:
  PointCloud();
  virtual ~PointCloud();

  virtual const char * const GetName() const { return "unknown"; };
  virtual Vector *GetCenter() const { return NULL; };
  virtual TesselPoint *GetPoint() const { return NULL; };
  virtual int GetMaxId() const { return 0; };
  virtual void GoToNext() const {};
  virtual void GoToFirst() const {};
  virtual bool IsEmpty() const { return true; };
  virtual bool IsEnd() const { return true; };
};


#endif /* POINTCLOUD_HPP_ */
